#include "abyss.h"
#include <locale.h>

pthread_mutex_t print_lock = PTHREAD_MUTEX_INITIALIZER;

/* nonblocking socket portcan */

u_short
sock_portscan (unsigned long ip)
{

  struct open_ports
  {
    int ports[p_list.max_port];
    char *service[p_list.max_port];
  } open_ports;

  int port, n, pcount = 0;
  int sockfd;
  time_t clock;
  struct tm *tm;
  struct servent *spt;
  char buf[BUF_LEN];
  int fail = 0;
  u_short open_port = 0;
  int speed;

  time (&clock);
  tm = gmtime (&clock);
  setlocale (LC_TIME, "C");
  strftime (buf, sizeof (buf), "%A, %B %e, %Y, %H:%M:%S", tm);

  if (opts.singlehost)
    Logprint ("AbysS [Report] - Starting new scan [%s]\n", buf);

  Logprint ("AbysS [Net] - Scanning [%s]   \n", inet_ntoa (ip));

  for (port = 0; port < p_list.max_port; port++)
    {
      pthread_mutex_lock (&print_lock);
      if ((sockfd = ip_connect (ip, p_list.port[port])) < 0)
	{
	  Logprint ("AbysS [Net] - Connection to %s failed\n",
		    inet_ntoa (ip));
	  fail = 1;
	  goto ghetto;
	}
      pthread_mutex_unlock (&print_lock);

      if ((n = port_connect (sockfd, 1)) == 1)
	{
	  open_ports.ports[pcount] = p_list.port[port];

	  spt = getservbyport (htons (p_list.port[port]), "tcp");
	  open_ports.service[pcount] = strdup (spt->s_name);

	  pthread_mutex_lock (&print_lock);
	  Logprint ("AbysS - [Net] %s -> Open Port: %d [%s]\n",
		    inet_ntoa (ip), p_list.port[port],
		    open_ports.service[pcount]);
	  pthread_mutex_unlock (&print_lock);

	  close (sockfd);

	  if (open_port == 0)
	    open_port = open_ports.ports[pcount];

	  pcount++;
	  continue;
	}
      close (sockfd);
      continue;
    }


  pthread_mutex_lock (&print_lock);
  Logprint ("AbysS [Report] - %s : %d Open ports - ...\n",
	    inet_ntoa (ip), pcount);
  pthread_mutex_unlock (&print_lock);

ghetto:
  if (fail == 1)
    {
      Logprint ("AbysS [EXIT_THREAD] - Connect error %s\n", inet_ntoa (ip));
      return -1;
    }
  else
    return open_port;

}
