#include "abyss.h"

extern unsigned long local_ip;

int
init_pcap_ (char *filter, ...)
{

  va_list va;
  extern char *dev;
  char string[BUF_LEN];
  struct local localhost;
  struct bpf_program fp;
  int link_;


  va_start (va, filter);
  vsnprintf (string, BUF_LEN - 1, filter, va);
  va_end (va);

  if (!opts.interface)
    dev = strdup (pcap_lookupdev (errbuf));

  if (pcap_lookupnet (dev, &localhost.ip, &localhost.mask, errbuf) == -1)
    {
      Logprint ("AbysS [PCAP] - Could not get local ip, and netmask for %s\n",
		dev);
      localhost.ip = 0;
      localhost.mask = 0;
      return -1;
    }
  p_handler = pcap_open_live (dev, BUF_LEN, 1, 1000, errbuf);

  if (p_handler == NULL)
    {
      Logprint ("AbysS [PCAP] - Could not open %s - %s\n", dev, errbuf);
      return -1;
    }

  if (pcap_compile (p_handler, &fp, string, 0, localhost.ip) == -1)
    {
      Logprint ("AbysS [PCAP] - Error compiling filter\n");
      return -1;
    }

  if (pcap_setfilter (p_handler, &fp) == -1)
    {
      Logprint ("AbysS [PCAP] - Error compiling filter\n");
      return -1;
    }

  link_ = pcap_datalink (p_handler);
  switch (link_)
    {
    case DLT_NULL:
      linktype = 4;
      break;
    case DLT_RAW:
      linktype = 0;
      break;
    case DLT_PPP:
      linktype = 4;
      break;
    case DLT_EN10MB:
      linktype = 14;
      break;
    }

  local_ip = localhost.ip;
  return 0;
}

void
pcap_done_ (void)
{
  pcap_close (p_handler);
}
