#include "abyss.h"

/* implementation of ping */
/* The icmp packet function is ping_net() in net.c */

void *
icmp_scan (void *arg)
{
  unsigned long int net;
  struct tm *tm;
  char buf[BUF_LEN];
  time_t clock;

  unsigned long ip;

  time (&clock);
  tm = gmtime (&clock);
  setlocale (LC_TIME, "C");
  strftime (buf, sizeof (buf), "%A, %B %e, %Y, %H:%M:%S", tm);

  printf ("AbysS [Net] - Starting new ICMP ping sweep %s\n", buf);
  printf ("The following hosts are up:\n");

  for (net = ntohl (addr.start_dest); net < ntohl (addr.final_dest); net++)
    {
      if ((net & 0xFF) == 0)
	net++;
      if ((net & 0xFF) == 255)
	net++;

      ip = htonl (net);
      if (opts.verbose)
	Logprint ("AbysS [Net] - PING [%s]\n", inet_ntoa (ip));

      ping_net (ip);
      sleep (ICMP_WAIT);
    }

}

void *
icmp_handler (void *arg)
{
  if ((pcap_loop (p_handler, -1, _icmp_handler, NULL)) < 0)
    {
      Logprint ("AbysS [PCAP] pcap_loop error %s\n", errbuf);
      exit (-1);
    }
  return NULL;
}

void
_icmp_handler (u_char * pargs, const struct pcap_pkthdr *packetheader,
	       const u_char * packetdata)
{
  struct ether_header *ether;
  struct ip_header *ip;
  struct icmp_header *icmp;
  ether = (struct ether_header *) packetdata;
  ip = (struct ip_header *) (packetdata + sizeof (struct ether_header));
  icmp =
    (struct icmp_header *) (packetdata + sizeof (struct ether_header) +
			    (ip->ip_hl * 4));

  if (ip->ip_p == IPPROTO_ICMP)
    {
      if (icmp->icmp_type == ICMP_ECHOREPLY)
	{
	  if (opts.verbose)
	    {
	      Logprint ("AbysS - [Net] Received ICMP ECHO REPLY from %s\n",
			inet_ntoa (ip->ip_src.s_addr));
	    }
	  Logprint ("%s\n", inet_ntoa (ip->ip_src.s_addr));
	}
    }
}
