#include "abyss.h"

/* split_prints creates an array of pointers to tokens (an argument array) */
/* And returns the number of tokens. This makes parsing the fingerprint file easy */

int
split_prints (char *s, char *delimiters, char ***argvp)
{
  char *t;
  char *snew;
  int numtokens;
  int i;

  snew = s + strspn (s, delimiters);

  if ((t = calloc (strlen (snew) + 1, sizeof (char))) == NULL)
    {
      *argvp = NULL;
      numtokens = -1;
    }
  else
    {
      strcpy (t, snew);
      if (strtok (t, delimiters) == NULL)
	numtokens = 0;
      else
	{
	  for (numtokens = 1; strtok (NULL, delimiters) != NULL; numtokens++)
	    //    free (t);
	    numtokens - 1;
	}

      if ((*argvp = calloc (numtokens + 1, sizeof (char *))) == NULL)
	{
	  //  free (t);
	  numtokens = -1;
	}
      else
	{
	  if (numtokens > 0)
	    {
	      strcpy (t, snew);
	      **argvp = strtok (t, delimiters);
	      for (i = 1; i < numtokens + 1; i++)
		*((*argvp) + i) = strtok (NULL, delimiters);
	    }
	  else
	    {
	      **argvp = NULL;
	      //      free (t);
	    }
	}
    }
  return numtokens;
}

/* getmask()  take in an arg like host.com/16, and depending */
/* on the netmask, it finds the first, and final ip of the class */

int
get_mask (char *stp)
{
  char *p;
  char *host;
  int netmask;

  /*        struct addrz {
     unsigned long int start_dest;
     unsigned long int final_dest;
     } addr;
   */
  struct hostent *hptr;
  host = stp;

  if ((p = strchr (host, '/')) == NULL)
    return -1;
  *p = NULL;

  if ((addr.start_dest = resolve_ip (host, (struct hostent *) hptr)) == -1)
    {
      Logprint ("AbysS [Net] - Could not resolve %s \n", host);
      exit (-1);
    }

  netmask = atoi (p + 1);
  if ((netmask != 8) && (netmask != 16) && (netmask != 24))
    return -1;

  addr.start_dest = ntohl (addr.start_dest);
  addr.final_dest = addr.start_dest;

  /* extract net-bitmask */
  /* class C: start_dest &= 2 * 64 (128) etc. */

  addr.start_dest &= ~(u_int32_t) ((2 << (31 - netmask)) - 1);
  addr.start_dest = htonl (addr.start_dest);

  /* Turn on all bits in the net bit mask */

  switch (netmask)
    {
    case 24:
      /* Class C */ addr.final_dest |= 0xFF;
      break;
    case 16:
      /* Class B */ addr.final_dest |= 0xFFFF;
      break;
    case 8:
      /* Class A */ addr.final_dest |= 0xFFFFFF;
      break;
    }

  addr.final_dest = htonl (addr.final_dest);
  return netmask;
}

/* This function turned out ridiculous, but it gets the job done */
/* it opens /etc/services and retrieves only the tcp ports */

int
get_tcp_ports (char *services)
{
  char *ptr, serv[MAX_STRING], buf[MAX_STRING], tmp[MAX_STRING], port[10];
  char *ctr, *brk;
  int i, j, tcp, ports[1024];
  FILE *fd;

  j = 0;

  if ((fd = fopen (services, "r")) == NULL)
    return -1;

  while ((fgets (buf, MAX_STRING, fd)) != NULL)
    {
      if ((ptr = strchr (buf, '\n')) != NULL)
	*(ptr) = '\0';

      if (buf[0] == '#')
	continue;

      if ((ptr = strchr (buf, '/')) != NULL)
	{
	  if ((*++ptr == 't') && (*++ptr == 'c') && (*++ptr == 'p'))
	    {
	      ptr -= 3;
	      while (!isdigit (*ptr))
		*ptr--;
	      while (isdigit (*ptr))
		*ptr--;
	      strcpy (tmp, ptr);
	      ctr = strtok_r (tmp, "/", &brk);
	      for (i = 0; i < 14; i++)
		{
		  if (*ctr != " ")
		    port[i] = *ctr;
		  *ctr++;
		}
	      tcp = atoi (port);
	      p_list.port[j++] = tcp;	//will change this to global
	    }
	}
      memset (buf, 0, MAX_STRING);
    }
  p_list.max_port = j;
  fclose (fd);
  return 1;
}

void
add_ip (char *ipname)
{
  struct host_list *tmp =
    (struct host_list *) malloc (sizeof (struct host_list));

  strcpy (tmp->ip, ipname);
  tmp->status = 0;
  tmp->next = iplist;
  iplist = tmp;

}

int
load_prints (char *os)
{
  struct os_list *tmp = (struct os_list *) malloc (sizeof (struct os_list));

  if (os)
    {
      strcpy (tmp->print, os);
      tmp->next = oslist;
      oslist = tmp;
    }

}
