#include "abyss.h"

int count = 0;
int open_port[1500];

int i = 0;

int
syn_portscan (unsigned long ip)
{
  int port = 0;
  time_t clock;
  struct tm *tm;
  char buf[BUF_LEN];
  int sockfd;

  extern unsigned long local_ip;

  time (&clock);
  tm = gmtime (&clock);
  setlocale (LC_TIME, "C");
  strftime (buf, sizeof (buf), "%A, %B %e, %Y, %H:%M:%S", tm);


  Logprint ("AbysS [Report] - Starting new scan [%s]\n", buf);
  Logprint ("AbysS [Net] - Scanning [%s]   \n", inet_ntoa (ip));

  /* n0n st34lth! SYN Sc4n! */
  /* Although we are using a nonblocking socket, our syn handler */
  /* is whats giving us speed. This way it is less likely */
  /* to flood the connection, and is actually faster. */
  /* NOTE: Because we do a full connection, we can be detected */
  /* HACKERS BEWARE */

  for (port = 0; port < p_list.max_port; port++)
    {
      sockfd = ip_connect (ip, p_list.port[port]);
      usleep (SYN_SEC);
      close (sockfd);
    }
  return;
}


void *
syn_handler (void *arg)
{
  if ((pcap_loop (p_handler, -1, _syn_handler, NULL)) < 0)
    {
      Logprint ("AbysS [PCAP] pcap_loop error %s\n", errbuf);
      exit (-1);
    }
  return NULL;
}

void
_syn_handler (u_char * pargs, const struct pcap_pkthdr *packetheader,
	      const u_char * packetdata)
{
  struct ether_header *ether;
  struct ip_header *ip;
  struct tcp_header *tcp;
  struct servent *spt;

  ether = (struct ether_header *) packetdata;
  ip = (struct ip *) (packetdata + sizeof (struct ether_header));
  tcp =
    (struct tcphdr *) (packetdata + sizeof (struct ether_header) +
		       (ip->ip_hl * 4));

  if (ip->ip_p == IPPROTO_TCP)
    {
      if (tcp->th_flags == (TH_SYN | TH_ACK))
	{
	  spt = getservbyport (tcp->th_sport, "tcp");
	  Logprint ("AbysS - [Net] %s -> Open Port: %d [%s]\n",
		    inet_ntoa (opts.ip), ntohs (tcp->th_sport), spt->s_name);
	}
      if (opts.verbose)
	{
	  if (tcp->th_flags & TH_RST)
	    Logprint ("AbysS - [Net] %s -> Closed Port: %d [%s]\n",
		      inet_ntoa (opts.ip), ntohs (tcp->th_sport),
		      spt->s_name);
	}
    }
}
